// s10_iopll_reconfig.v

// Generated using ACDS version 18.1.1 263

`timescale 1 ps / 1 ps
module s10_iopll_reconfig #(
		parameter device_family            = "Stratix 10",
		parameter SHIFT_REGISTER_DEPTH     = 0,
		parameter DPRIO_ADDR_WIDTH         = 8,
		parameter DPRIO_DATA_WIDTH         = 8,
		parameter DPRIO_MODE_SEL_WIDTH     = 2,
		parameter ROM_ADDR_WIDTH           = 2,
		parameter ROM_DATA_WIDTH           = 16,
		parameter ROM_NUM_WORDS            = 3,
		parameter TO_PLL_WIDTH             = 30,
		parameter FROM_PLL_WIDTH           = 11,
		parameter DPRIO_GATING_ADDR        = 22,
		parameter MIF_EOF                  = 65535,
		parameter WAIT_FOR_LOCK            = "false",
		parameter AVALON_ADDR_TIEOFF_WIDTH = 0,
		parameter reconfig_mif_filename    = "recalibration.mif",
		parameter ADVANCED_RECONFIG        = "false",
		parameter MIF_ADDRESS_0            = 0,
		parameter MIF_ADDRESS_1            = 0,
		parameter MIF_ADDRESS_2            = 0,
		parameter MIF_ADDRESS_3            = 0,
		parameter MIF_ADDRESS_4            = 0,
		parameter MIF_ADDRESS_5            = 0,
		parameter MIF_ADDRESS_6            = 0,
		parameter MIF_ADDRESS_7            = 0,
		parameter MIF_ADDRESS_8            = 0,
		parameter MIF_ADDRESS_9            = 0,
		parameter MIF_ADDRESS_10           = 0,
		parameter MIF_ADDRESS_11           = 0,
		parameter MIF_ADDRESS_12           = 0,
		parameter MIF_ADDRESS_13           = 0,
		parameter MIF_ADDRESS_14           = 0,
		parameter MIF_ADDRESS_15           = 0,
		parameter MIF_ADDRESS_16           = 0,
		parameter MIF_ADDRESS_17           = 0,
		parameter MIF_ADDRESS_18           = 0,
		parameter MIF_ADDRESS_19           = 0,
		parameter MIF_ADDRESS_20           = 0,
		parameter MIF_ADDRESS_21           = 0,
		parameter MIF_ADDRESS_22           = 0,
		parameter MIF_ADDRESS_23           = 0,
		parameter MIF_ADDRESS_24           = 0,
		parameter MIF_ADDRESS_25           = 0,
		parameter MIF_ADDRESS_26           = 0,
		parameter MIF_ADDRESS_27           = 0,
		parameter MIF_ADDRESS_28           = 0,
		parameter MIF_ADDRESS_29           = 0,
		parameter MIF_ADDRESS_30           = 0,
		parameter MIF_ADDRESS_31           = 0
	) (
		input  wire        mgmt_clk,          //          mgmt_clk.clk
		input  wire        mgmt_reset,        //        mgmt_reset.reset
		output wire        mgmt_waitrequest,  // mgmt_avalon_slave.waitrequest
		input  wire        mgmt_write,        //                  .write
		input  wire        mgmt_read,         //                  .read
		input  wire [7:0]  mgmt_writedata,    //                  .writedata
		output wire [7:0]  mgmt_readdata,     //                  .readdata
		input  wire [9:0]  mgmt_address,      //                  .address
		output wire [29:0] reconfig_to_pll,   //   reconfig_to_pll.reconfig_to_pll
		input  wire [10:0] reconfig_from_pll  // reconfig_from_pll.reconfig_from_pll
	);

	generate
		// If any of the display statements (or deliberately broken
		// instantiations) within this generate block triggers then this module
		// has been instantiated this module with a set of parameters different
		// from those it was generated for.  This will usually result in a
		// non-functioning system.
		if (device_family != "Stratix 10")
		begin
			initial begin
				$display("Generated module instantiated with wrong parameters");
				$stop;
			end
			instantiated_with_wrong_parameters_error_see_comment_above
					device_family_check ( .error(1'b1) );
		end
		if (SHIFT_REGISTER_DEPTH != 0)
		begin
			initial begin
				$display("Generated module instantiated with wrong parameters");
				$stop;
			end
			instantiated_with_wrong_parameters_error_see_comment_above
					shift_register_depth_check ( .error(1'b1) );
		end
		if (DPRIO_ADDR_WIDTH != 8)
		begin
			initial begin
				$display("Generated module instantiated with wrong parameters");
				$stop;
			end
			instantiated_with_wrong_parameters_error_see_comment_above
					dprio_addr_width_check ( .error(1'b1) );
		end
		if (DPRIO_DATA_WIDTH != 8)
		begin
			initial begin
				$display("Generated module instantiated with wrong parameters");
				$stop;
			end
			instantiated_with_wrong_parameters_error_see_comment_above
					dprio_data_width_check ( .error(1'b1) );
		end
		if (DPRIO_MODE_SEL_WIDTH != 2)
		begin
			initial begin
				$display("Generated module instantiated with wrong parameters");
				$stop;
			end
			instantiated_with_wrong_parameters_error_see_comment_above
					dprio_mode_sel_width_check ( .error(1'b1) );
		end
		if (ROM_ADDR_WIDTH != 2)
		begin
			initial begin
				$display("Generated module instantiated with wrong parameters");
				$stop;
			end
			instantiated_with_wrong_parameters_error_see_comment_above
					rom_addr_width_check ( .error(1'b1) );
		end
		if (ROM_DATA_WIDTH != 16)
		begin
			initial begin
				$display("Generated module instantiated with wrong parameters");
				$stop;
			end
			instantiated_with_wrong_parameters_error_see_comment_above
					rom_data_width_check ( .error(1'b1) );
		end
		if (ROM_NUM_WORDS != 3)
		begin
			initial begin
				$display("Generated module instantiated with wrong parameters");
				$stop;
			end
			instantiated_with_wrong_parameters_error_see_comment_above
					rom_num_words_check ( .error(1'b1) );
		end
		if (TO_PLL_WIDTH != 30)
		begin
			initial begin
				$display("Generated module instantiated with wrong parameters");
				$stop;
			end
			instantiated_with_wrong_parameters_error_see_comment_above
					to_pll_width_check ( .error(1'b1) );
		end
		if (FROM_PLL_WIDTH != 11)
		begin
			initial begin
				$display("Generated module instantiated with wrong parameters");
				$stop;
			end
			instantiated_with_wrong_parameters_error_see_comment_above
					from_pll_width_check ( .error(1'b1) );
		end
		if (DPRIO_GATING_ADDR != 22)
		begin
			initial begin
				$display("Generated module instantiated with wrong parameters");
				$stop;
			end
			instantiated_with_wrong_parameters_error_see_comment_above
					dprio_gating_addr_check ( .error(1'b1) );
		end
		if (MIF_EOF != 65535)
		begin
			initial begin
				$display("Generated module instantiated with wrong parameters");
				$stop;
			end
			instantiated_with_wrong_parameters_error_see_comment_above
					mif_eof_check ( .error(1'b1) );
		end
		if (WAIT_FOR_LOCK != "false")
		begin
			initial begin
				$display("Generated module instantiated with wrong parameters");
				$stop;
			end
			instantiated_with_wrong_parameters_error_see_comment_above
					wait_for_lock_check ( .error(1'b1) );
		end
		if (AVALON_ADDR_TIEOFF_WIDTH != 0)
		begin
			initial begin
				$display("Generated module instantiated with wrong parameters");
				$stop;
			end
			instantiated_with_wrong_parameters_error_see_comment_above
					avalon_addr_tieoff_width_check ( .error(1'b1) );
		end
		if (reconfig_mif_filename != "recalibration.mif")
		begin
			initial begin
				$display("Generated module instantiated with wrong parameters");
				$stop;
			end
			instantiated_with_wrong_parameters_error_see_comment_above
					reconfig_mif_filename_check ( .error(1'b1) );
		end
		if (ADVANCED_RECONFIG != "false")
		begin
			initial begin
				$display("Generated module instantiated with wrong parameters");
				$stop;
			end
			instantiated_with_wrong_parameters_error_see_comment_above
					advanced_reconfig_check ( .error(1'b1) );
		end
		if (MIF_ADDRESS_0 != 0)
		begin
			initial begin
				$display("Generated module instantiated with wrong parameters");
				$stop;
			end
			instantiated_with_wrong_parameters_error_see_comment_above
					mif_address_0_check ( .error(1'b1) );
		end
		if (MIF_ADDRESS_1 != 0)
		begin
			initial begin
				$display("Generated module instantiated with wrong parameters");
				$stop;
			end
			instantiated_with_wrong_parameters_error_see_comment_above
					mif_address_1_check ( .error(1'b1) );
		end
		if (MIF_ADDRESS_2 != 0)
		begin
			initial begin
				$display("Generated module instantiated with wrong parameters");
				$stop;
			end
			instantiated_with_wrong_parameters_error_see_comment_above
					mif_address_2_check ( .error(1'b1) );
		end
		if (MIF_ADDRESS_3 != 0)
		begin
			initial begin
				$display("Generated module instantiated with wrong parameters");
				$stop;
			end
			instantiated_with_wrong_parameters_error_see_comment_above
					mif_address_3_check ( .error(1'b1) );
		end
		if (MIF_ADDRESS_4 != 0)
		begin
			initial begin
				$display("Generated module instantiated with wrong parameters");
				$stop;
			end
			instantiated_with_wrong_parameters_error_see_comment_above
					mif_address_4_check ( .error(1'b1) );
		end
		if (MIF_ADDRESS_5 != 0)
		begin
			initial begin
				$display("Generated module instantiated with wrong parameters");
				$stop;
			end
			instantiated_with_wrong_parameters_error_see_comment_above
					mif_address_5_check ( .error(1'b1) );
		end
		if (MIF_ADDRESS_6 != 0)
		begin
			initial begin
				$display("Generated module instantiated with wrong parameters");
				$stop;
			end
			instantiated_with_wrong_parameters_error_see_comment_above
					mif_address_6_check ( .error(1'b1) );
		end
		if (MIF_ADDRESS_7 != 0)
		begin
			initial begin
				$display("Generated module instantiated with wrong parameters");
				$stop;
			end
			instantiated_with_wrong_parameters_error_see_comment_above
					mif_address_7_check ( .error(1'b1) );
		end
		if (MIF_ADDRESS_8 != 0)
		begin
			initial begin
				$display("Generated module instantiated with wrong parameters");
				$stop;
			end
			instantiated_with_wrong_parameters_error_see_comment_above
					mif_address_8_check ( .error(1'b1) );
		end
		if (MIF_ADDRESS_9 != 0)
		begin
			initial begin
				$display("Generated module instantiated with wrong parameters");
				$stop;
			end
			instantiated_with_wrong_parameters_error_see_comment_above
					mif_address_9_check ( .error(1'b1) );
		end
		if (MIF_ADDRESS_10 != 0)
		begin
			initial begin
				$display("Generated module instantiated with wrong parameters");
				$stop;
			end
			instantiated_with_wrong_parameters_error_see_comment_above
					mif_address_10_check ( .error(1'b1) );
		end
		if (MIF_ADDRESS_11 != 0)
		begin
			initial begin
				$display("Generated module instantiated with wrong parameters");
				$stop;
			end
			instantiated_with_wrong_parameters_error_see_comment_above
					mif_address_11_check ( .error(1'b1) );
		end
		if (MIF_ADDRESS_12 != 0)
		begin
			initial begin
				$display("Generated module instantiated with wrong parameters");
				$stop;
			end
			instantiated_with_wrong_parameters_error_see_comment_above
					mif_address_12_check ( .error(1'b1) );
		end
		if (MIF_ADDRESS_13 != 0)
		begin
			initial begin
				$display("Generated module instantiated with wrong parameters");
				$stop;
			end
			instantiated_with_wrong_parameters_error_see_comment_above
					mif_address_13_check ( .error(1'b1) );
		end
		if (MIF_ADDRESS_14 != 0)
		begin
			initial begin
				$display("Generated module instantiated with wrong parameters");
				$stop;
			end
			instantiated_with_wrong_parameters_error_see_comment_above
					mif_address_14_check ( .error(1'b1) );
		end
		if (MIF_ADDRESS_15 != 0)
		begin
			initial begin
				$display("Generated module instantiated with wrong parameters");
				$stop;
			end
			instantiated_with_wrong_parameters_error_see_comment_above
					mif_address_15_check ( .error(1'b1) );
		end
		if (MIF_ADDRESS_16 != 0)
		begin
			initial begin
				$display("Generated module instantiated with wrong parameters");
				$stop;
			end
			instantiated_with_wrong_parameters_error_see_comment_above
					mif_address_16_check ( .error(1'b1) );
		end
		if (MIF_ADDRESS_17 != 0)
		begin
			initial begin
				$display("Generated module instantiated with wrong parameters");
				$stop;
			end
			instantiated_with_wrong_parameters_error_see_comment_above
					mif_address_17_check ( .error(1'b1) );
		end
		if (MIF_ADDRESS_18 != 0)
		begin
			initial begin
				$display("Generated module instantiated with wrong parameters");
				$stop;
			end
			instantiated_with_wrong_parameters_error_see_comment_above
					mif_address_18_check ( .error(1'b1) );
		end
		if (MIF_ADDRESS_19 != 0)
		begin
			initial begin
				$display("Generated module instantiated with wrong parameters");
				$stop;
			end
			instantiated_with_wrong_parameters_error_see_comment_above
					mif_address_19_check ( .error(1'b1) );
		end
		if (MIF_ADDRESS_20 != 0)
		begin
			initial begin
				$display("Generated module instantiated with wrong parameters");
				$stop;
			end
			instantiated_with_wrong_parameters_error_see_comment_above
					mif_address_20_check ( .error(1'b1) );
		end
		if (MIF_ADDRESS_21 != 0)
		begin
			initial begin
				$display("Generated module instantiated with wrong parameters");
				$stop;
			end
			instantiated_with_wrong_parameters_error_see_comment_above
					mif_address_21_check ( .error(1'b1) );
		end
		if (MIF_ADDRESS_22 != 0)
		begin
			initial begin
				$display("Generated module instantiated with wrong parameters");
				$stop;
			end
			instantiated_with_wrong_parameters_error_see_comment_above
					mif_address_22_check ( .error(1'b1) );
		end
		if (MIF_ADDRESS_23 != 0)
		begin
			initial begin
				$display("Generated module instantiated with wrong parameters");
				$stop;
			end
			instantiated_with_wrong_parameters_error_see_comment_above
					mif_address_23_check ( .error(1'b1) );
		end
		if (MIF_ADDRESS_24 != 0)
		begin
			initial begin
				$display("Generated module instantiated with wrong parameters");
				$stop;
			end
			instantiated_with_wrong_parameters_error_see_comment_above
					mif_address_24_check ( .error(1'b1) );
		end
		if (MIF_ADDRESS_25 != 0)
		begin
			initial begin
				$display("Generated module instantiated with wrong parameters");
				$stop;
			end
			instantiated_with_wrong_parameters_error_see_comment_above
					mif_address_25_check ( .error(1'b1) );
		end
		if (MIF_ADDRESS_26 != 0)
		begin
			initial begin
				$display("Generated module instantiated with wrong parameters");
				$stop;
			end
			instantiated_with_wrong_parameters_error_see_comment_above
					mif_address_26_check ( .error(1'b1) );
		end
		if (MIF_ADDRESS_27 != 0)
		begin
			initial begin
				$display("Generated module instantiated with wrong parameters");
				$stop;
			end
			instantiated_with_wrong_parameters_error_see_comment_above
					mif_address_27_check ( .error(1'b1) );
		end
		if (MIF_ADDRESS_28 != 0)
		begin
			initial begin
				$display("Generated module instantiated with wrong parameters");
				$stop;
			end
			instantiated_with_wrong_parameters_error_see_comment_above
					mif_address_28_check ( .error(1'b1) );
		end
		if (MIF_ADDRESS_29 != 0)
		begin
			initial begin
				$display("Generated module instantiated with wrong parameters");
				$stop;
			end
			instantiated_with_wrong_parameters_error_see_comment_above
					mif_address_29_check ( .error(1'b1) );
		end
		if (MIF_ADDRESS_30 != 0)
		begin
			initial begin
				$display("Generated module instantiated with wrong parameters");
				$stop;
			end
			instantiated_with_wrong_parameters_error_see_comment_above
					mif_address_30_check ( .error(1'b1) );
		end
		if (MIF_ADDRESS_31 != 0)
		begin
			initial begin
				$display("Generated module instantiated with wrong parameters");
				$stop;
			end
			instantiated_with_wrong_parameters_error_see_comment_above
					mif_address_31_check ( .error(1'b1) );
		end
	endgenerate

	altera_iopll_reconfig_top #(
		.device_family            ("Stratix 10"),
		.SHIFT_REGISTER_DEPTH     (0),
		.DPRIO_ADDR_WIDTH         (8),
		.DPRIO_DATA_WIDTH         (8),
		.DPRIO_MODE_SEL_WIDTH     (2),
		.ROM_ADDR_WIDTH           (2),
		.ROM_DATA_WIDTH           (16),
		.ROM_NUM_WORDS            (3),
		.TO_PLL_WIDTH             (30),
		.FROM_PLL_WIDTH           (11),
		.DPRIO_GATING_ADDR        (22),
		.MIF_EOF                  (65535),
		.WAIT_FOR_LOCK            ("false"),
		.AVALON_ADDR_TIEOFF_WIDTH (0),
		.reconfig_mif_filename    ("recalibration.mif"),
		.ADVANCED_RECONFIG        ("false"),
		.MIF_ADDRESS_0            (0),
		.MIF_ADDRESS_1            (0),
		.MIF_ADDRESS_2            (0),
		.MIF_ADDRESS_3            (0),
		.MIF_ADDRESS_4            (0),
		.MIF_ADDRESS_5            (0),
		.MIF_ADDRESS_6            (0),
		.MIF_ADDRESS_7            (0),
		.MIF_ADDRESS_8            (0),
		.MIF_ADDRESS_9            (0),
		.MIF_ADDRESS_10           (0),
		.MIF_ADDRESS_11           (0),
		.MIF_ADDRESS_12           (0),
		.MIF_ADDRESS_13           (0),
		.MIF_ADDRESS_14           (0),
		.MIF_ADDRESS_15           (0),
		.MIF_ADDRESS_16           (0),
		.MIF_ADDRESS_17           (0),
		.MIF_ADDRESS_18           (0),
		.MIF_ADDRESS_19           (0),
		.MIF_ADDRESS_20           (0),
		.MIF_ADDRESS_21           (0),
		.MIF_ADDRESS_22           (0),
		.MIF_ADDRESS_23           (0),
		.MIF_ADDRESS_24           (0),
		.MIF_ADDRESS_25           (0),
		.MIF_ADDRESS_26           (0),
		.MIF_ADDRESS_27           (0),
		.MIF_ADDRESS_28           (0),
		.MIF_ADDRESS_29           (0),
		.MIF_ADDRESS_30           (0),
		.MIF_ADDRESS_31           (0)
	) s10_iopll_reconfig (
		.mgmt_clk          (mgmt_clk),          //   input,   width = 1,          mgmt_clk.clk
		.mgmt_reset        (mgmt_reset),        //   input,   width = 1,        mgmt_reset.reset
		.mgmt_waitrequest  (mgmt_waitrequest),  //  output,   width = 1, mgmt_avalon_slave.waitrequest
		.mgmt_write        (mgmt_write),        //   input,   width = 1,                  .write
		.mgmt_read         (mgmt_read),         //   input,   width = 1,                  .read
		.mgmt_writedata    (mgmt_writedata),    //   input,   width = 8,                  .writedata
		.mgmt_readdata     (mgmt_readdata),     //  output,   width = 8,                  .readdata
		.mgmt_address      (mgmt_address),      //   input,  width = 10,                  .address
		.reconfig_to_pll   (reconfig_to_pll),   //  output,  width = 30,   reconfig_to_pll.reconfig_to_pll
		.reconfig_from_pll (reconfig_from_pll)  //   input,  width = 11, reconfig_from_pll.reconfig_from_pll
	);

endmodule
